/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
/**
	Audio source NT-service

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_audio_source_h
#define mp3_audio_source_h

#include <zz_nt_service.h>
#include "mp3_streamer.h"
#include "mp3_playlist_handler.h"
#include <mp3_stream_server.h>

#ifdef BUILD_MYMUSIC_DEMO
#define SOURCE_SVC_NAME "myMusic_AudioSource_DEMO"
#else
#define SOURCE_SVC_NAME "myMusic_AudioSource"
#endif

#define SOURCE_SVC_DESCRIPTION "Streaming audiosource for myMusic (compatible with Icecast and Shoutcast servers)"

class Cmp3AudioSource : public CzzNTService
{
public:

	//* Construction
	Cmp3AudioSource();
	virtual ~Cmp3AudioSource();

	// When service starts
	virtual void OnStart( int argc, char** argv );
	virtual void OnStop( void );

protected:
private:

	void StartJobs( void );

	map<CzzString, Cmp3Streamer* > m_Streamers;
	Cmp3PlayListHandler* m_PlaylistHandler;
};

#endif // mp3_audio_source_h