/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	Low level API functions for myMusic configuration utility

	(C) Copyright 2005 Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_api_h
#define mp3_api_h

#ifdef __cplusplus
	extern "C" {
#endif

/* API */
#define MP3API short _declspec(dllexport) __stdcall

/* Error codes */
#define MP3_UNDEFINED_ERROR	-1
#define MP3_SEND_FAILED		 1
#define MP3_NO_REPLY		 2
#define MP3_NOT_FOUND		 3
#define MP3_BUFF_TO_SMALL	 4
#define MP3_COULD_NOT_EXECUTE 5
#define MP3_STACK_EMPTY       6
#define MP3_ACCESS_DENIED     7
#define MP3_INTERNAL          8
#define MP3_NO_END            9
#define MP3_ATTACH_FAILED     10

/** Get global IP adress */
MP3API mp3_getGlobalIPAdress( char* buff, short size );

/** Get last error */
MP3API mp3_getLastError( short* code, char* buff, short size );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* mp3_api_h */ 

