/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3HttpRequester

#include "mp3_http_requester.h"
#include <zz_base64.h>
#include <zz_exception.h>
#include "regexp.h"

// Construction
Cmp3HttpRequester::Cmp3HttpRequester( const char* host )
: CzzHTTP( host, "80", "onoffline", 3, 3 ), m_Log( "mp3_api" )
{
	
}

// Destruction
Cmp3HttpRequester::~Cmp3HttpRequester()
{
	
}

CzzString Cmp3HttpRequester::getPublicIP( void )
{
	// checkip.dyndns.org

#ifdef _DEBUG
	CzzString url = "/cgi-bin/dyndns.exe?checkip=1";
#else
	CzzString url = "/";
#endif
	m_ResponseFile = "";

	// Request
	addRequest( "GET", url.c_str() );
	
	// Headers
	addHeader( "Host: %s", m_LocalHost.c_str() );
	addHeader( "User-Agent: onoffline/1.0 (%s)", m_UserAgent.c_str() );
	addHeader( "Accept: %s", "application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*" );
	addHeader( "Connection: %s", "close" );
	addEndMarker();

	send();

	delete m_SendBuffer;
	m_SendBuffer = NULL;

	reply();

	// <html><head><title>Current IP Check</title></head><body>Current IP Address: 85.226.149.215</body></html>

	int t = m_Buffer.find( "</body>" );
	int f = m_Buffer.find( "Address: " );

	CzzString result = m_Buffer.substr( f+10-1, t-(f+10)+1 );

	if( !CRegExp::isValidIP( result ) )
		throw CzzException( _LAF, 4711, CzzString::Format( "Not a valid IP: %s", result.c_str() ));

	return result;
}

void Cmp3HttpRequester::writeToFile( long from, long size )
{
	char* tmp = new char[size+1];

	m_ReplyBuffer + from, size;
	memcpy( tmp, m_ReplyBuffer + from, size );
	tmp[size] = '\0';
	m_Buffer = m_Buffer + tmp;
	delete [] tmp;
}


