/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3ArtistListRender

#include "mp3_artist_list_render.h"
#include "mp3_general_data.h"
#include "mp3_config.h"
#include "mp3_artist_list_data.h"
#include "mp3_svc.h"

// Construction
Cmp3ArtistListRender::Cmp3ArtistListRender( void* session, CzzParameterMap* cgi )
: CzzOutputRender( CzzString::Format( ".\\%s\\%s\\renderList.html", Cmp3Config::getLang().c_str(), Cmp3Config::getSkin().c_str() ) , session, cgi )
{

	CzzString index("A");
	CzzString back_url = CzzString::Format( "%s/mp3_gui.exe?svc=%d", Cmp3Config::getCGIDir().c_str(), MP3_SVC_LIST_ARTISTS );

	try { index = (*cgi)[MP3_CGI_PAR_INDEX]; } catch( ... ) { }


	this->addFieldSvc( new Cmp3GeneralData( back_url, "myMusic", 
		CzzString::Format( "%s%s'", Cmp3Config::HEADLINE_ARTIST_INDEX().c_str(), index.c_str() )) );
	
	this->addListSvc( MP3_FLD_TABLE, new Cmp3ArtistListData( ) );
}

// Destruction
Cmp3ArtistListRender::~Cmp3ArtistListRender()
{

}

