/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3FramesData

#include "mp3_frames_data.h"
#include "mp3_config.h"
#include "mp3_svc.h"

// Construction
Cmp3FramesData::Cmp3FramesData( void )
 : CzzDataService( "getFramesData" )
{

}

// Destruction
Cmp3FramesData::~Cmp3FramesData()
{

}

CzzDataServiceReply* Cmp3FramesData::execute( void* session, CzzParameterMap* req )
{
	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();


	reply->addField( MP3_FLD_RENDER_TOP, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_TOP ) );

	reply->addField( MP3_FLD_RENDER_LEFT, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LEFT ) );

	reply->addField( MP3_FLD_RENDER_MAIN, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS ) );

	return reply;
}

int Cmp3FramesData::size()
{
    return sizeof(Cmp3FramesData);
}