/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	Sorted list

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_list_h
#define mp3_list_h

#include <zz_string.h>
#include <vector>
#include "mp3_list_item.h"

typedef vector<Cmp3ListItem*> Cmp3AlbumList;

class Cmp3List
{
public:

	//* Construction
	Cmp3List();
	Cmp3List( bool sorted );
	~Cmp3List();

	int size( void );
	void add( const char* item, long time );
	void add( const char* name, const char* album, long time );
	Cmp3ListItem* first( void );
	Cmp3ListItem* last( void );
	Cmp3ListItem* next( void );
	void rewind( void );
	
private:
	void sortList( void );

	Cmp3AlbumList m_List;
	bool m_Sorted;
	bool m_DoSort;
	vector<Cmp3ListItem* >::iterator m_Iterator;
	bool m_Init;

};

#endif // mp3_list_h