/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3MyRadioRender

#include "mp3_http_requester.h"
#include "mp3_myradio_render.h"
#include "mp3_general_data.h"
#include "mp3_config.h"
#include "mp3_myradio_list_data.h"
#include "mp3_myradio_channels_data.h"
#include "mp3_myradio_data.h"
#include "mp3_svc.h"

// Construction
Cmp3MyRadioRender::Cmp3MyRadioRender( void* session, CzzParameterMap* cgi, int svc )
: CzzOutputRender( CzzString::Format( ".\\%s\\%s\\renderMyRadio.html", Cmp3Config::getLang().c_str(), Cmp3Config::getSkin().c_str() ) , session, cgi )
{

	if( svc > 0 )
	{
		Cmp3HttpRequester req;
		CzzString name;
		CzzString album;
		CzzString song;

		if( svc == MP3_SVC_LIST_RADIO_CLEAR )
			req.clearRadioQueue();

		if( svc == MP3_SVC_LIST_RADIO_RAND )
			req.randomizeRadioQueue();

		if( svc == MP3_SVC_LIST_RADIO_FORWARD )
			req.skipForwardRadioQueue();

		if( svc == MP3_SVC_LIST_RADIO_REVERSE )
			req.skipReverseRadioQueue();

		if( svc == MP3_SVC_LIST_RADIO_REMOVE )
		{
			name = (*cgi)[ "name" ];
			album = (*cgi)[ "album" ];
			song = (*cgi)[ "song" ];
			req.removeFromRadioQueue( name.c_str(), album.c_str(), song.c_str() );
		}
	}

	CzzString back_url = CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=A", 
											Cmp3Config::getCGIDir().c_str(), 
											MP3_SVC_LIST_ARTISTS );

	this->addFieldSvc( new Cmp3GeneralData( back_url, "myMusic", 
		CzzString::Format( "%s - %s", 
				Cmp3Config::HEADLINE_MYRADIO_INDEX_1().c_str(),
				Cmp3Config::HEADLINE_MYRADIO_INDEX_2().c_str())) );
	
	this->addFieldSvc( new Cmp3MyRadioData() );
	this->addListSvc( MP3_FLD_TABLE, new Cmp3MyRadioListData( ) );
    this->addListSvc( "others", new Cmp3MyRadioChannelsData( ) );
}

// Destruction
Cmp3MyRadioRender::~Cmp3MyRadioRender()
{

}

