/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
/**
	Trd som betjnar ett anrop frn en klient

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_worker_thread_h
#define mp3_worker_thread_h

#include <zz_http_server.h>
#include <zz_win_thread.h>
#include <zz_http_request.h>
#include <zz_log.h>
#include <zz_win_threadmutex.h>

class Cmp3WorkerThread : public CzzWinThread, CzzHTTPServer
{
public:

	//* Construction
	Cmp3WorkerThread( CzzAccessLog* log, CzzHTTPRequest* req );
	virtual ~Cmp3WorkerThread();

	virtual void OnStart( void );

protected:
private:

	bool checkAuth( CzzHTTPRequest* req );

    // Services
    int execute_cgi_script( CzzHTTPRequest* req, CzzString& script, CzzString& params );
	int get_file( CzzHTTPRequest* req, CzzString& uri );
    
    // Errors
    int serviceNotFound( const char* msg );
    int internalError( const char* msg );
	void notAuthorized( void );

	// Helpers
	CzzString getDate( void );
	CzzString translateToLocal( CzzString& uri );
    CzzString urlDecode( const CzzString& url );
	CzzString trim( const CzzString& in );

	bool createChildProcess( char* env, const char* cmd, PROCESS_INFORMATION* pinfo, STARTUPINFO* sinfo );

	CzzLog m_Log;
	CzzString m_User;
	CzzString m_IP;
	CzzHTTPRequest* m_LastRequest;

	static CzzWinThreadMutex m_Mutex;
};

#endif // mp3_worker_thread_h