/* mini
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_class_loader_h
#define zz_class_loader_h

#include <zz_export.h>
#include <windows.h>

/** Prototype for a constructor */
typedef void (WINAPI * MINI_SVC_CTOR) ();

/** Prototype for a destructor */
typedef void (WINAPI * MINI_SVC_DTOR) ();

/** Prototype for a size method */
typedef int  (WINAPI * MINI_SVC_CLASS_SIZE) ();

/**
	Dynamic C++ classloader

	@author Toni Thomsson, toni@tonjac.org
*/
class ZZ_API CzzClassLoader
{

public:
    ~CzzClassLoader();

    /** 
        Create a object
        @param  dllname     Name of DLL containing the class to load
        @param  classname   Class to load

        @return new object
    */
    static void* createObject( const char* dllname, const char* classname );

    /** 
        Free a object
        @param  dllname     Name of DLL containing the class to free
        @param  classname   Class of object to free
        @param  obj         Pointer to object that should be freed

        @return NULL
    */
    static void* deleteObject( const char* dllname, const char* classname, void* obj );

protected:
private:
    CzzClassLoader();
};

#endif // zz_class_loader_h