/* mini
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_default_error_data_h
#define zz_default_error_data_h

#include <zz_data_service.h>
#include <mini.h>

/**
    Default error data service, sets the fields Error and Code
    to error message and code taken from the session.

    @author Toni Thomsson, toni@tonjac.org
*/
class ZZ_API CzzDefaultErrorData : public CzzDataService
{
public:

    /**
        Construction
    */
    CzzDefaultErrorData( void );
    virtual ~CzzDefaultErrorData();

    /**
        Called when service data is needed

        @param session Session-id
        @param req CGI-parameter-list
    */
    virtual CzzDataServiceReply* execute( void* session, CzzParameterMap* req );

    int size();
};

#endif // zz_default_error_data_h
